/* 
 *  This file is part of NOALYSS and is under GPL see licence.txt 
 *  Copyright (c) 2002 Author Dany De Bontridder dany@alchimerys.be
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */



    /**
     * Check all the operations
     * @returns {undefined}
     */
    function impb_check_all() {
        waiting_box();
        var check = ($('check_all').checked) ? 1 : 0;
        

        var tb = document.getElementById('record_tb_id');
        var a = tb.getElementsByTagName('input');


        var i = 0;
        nb = a.length;
        for (i = 0; i < a.length; i++) {
            if (a[i].id == 'check_all') {
                continue;
            }

            // Avoid selecting the no visible row
            if (!a[i].parentNode.parentNode.visible()) {
                continue;
            }

            if (check == 0) {
                a[i].checked = false;
            } else {
                a[i].checked = true;
            }
            var row_id = a[i].id;
            row_id = row_id.replace(/temp_bank/, "");
            impb_check_item(gDossier, plugin_code, row_id, false);

        }
        remove_waiting_box();
    }

    function display_duplicate(p_id) {
        waiting_box();
        new Ajax.Request('ajax.php',
            {
                method: 'get',
                parameters: {
                    'gDossier':gDossier,
                    'act': 'display_duplicate',
                    'plugin_code': plugin_code,
                    'temp_bank_id': p_id,
                    'ac': ac
                },
                onSuccess: function (req, json) {
                    remove_waiting_box();
                    var pos = fixed_position(50, 100);
                    // Display a div to select the tiers
                    var div1 = {
                        "id": "display_duplicate_div_id",
                        "cssclass": "inner_box",
                        "style": pos,
                        "html": req.responseText
                    };
                    try {
                        add_div(div1);
                        req.responseText.evalScripts();
                    } catch (e) {
                        error_message(e.getMessage);
                    }

                }
            });
    }

    var lastcheck = null;
    var endcheck = null;

    /**
     * For each checkbox , add an event on click
     * @param {string} p_range_name name of the checkbox object
     * @returns {undefined}
     */
    var importbankjs = {
        activate_checkbox_range: function (p_range_name) {
            let node_lstCheckBox = document.getElementsByClassName(p_range_name);
            var aCheckBox = Array.from(node_lstCheckBox)
            if (aCheckBox == undefined) {
                console.error("activate_checkbox_range_failed")
            }

            aCheckBox.forEach(elt => elt.addEventListener('click', function (event) {
                importbankjs.checkbox_set_range(event, elt, p_range_name);
            }, false));
        },


        /**
         * Check or uncheck checkbox if shift key is pressed and between the last checked elemet and the current one
         * @param {type} evt event
         * @param {type} elt Dom element
         * @param {type} p_name name of range
         */
        checkbox_set_range: function (evt, elt, p_name) {
            waiting_box();
         
            if (!evt.shiftKey) {
                lastcheck = elt;
                return;
            }
            var aName = document.getElementsByClassName(p_name);

            var from = 0;
            var end = 0;
            for (var i = 0; i < aName.length; i++) {
                if (aName[i] == elt) {
                    endcheck = aName[i];
                    from = i;
                }
                if (aName[i] == lastcheck) {
                       end = i;
                }
            }
            if (from > end) {
                let a = from;
                from = end;
                end = a;
            }
            var check = (aName[from].checked) ? true : false;
            for (x = from+1; x < end; x++) {
                if (aName[x].parentNode.parentNode.visible()) {
                    aName[x].click();
                    aName[x].checked = check;
                }
            }
            remove_waiting_box();
        }
    };


