<?php
  /*
   *   This file is part of NOALYSS.
   *
   *   NOALYSS is free software; you can redistribute it and/or modify
   *   it under the terms of the GNU General Public License as published by
   *   the Free Software Foundation; either version 2 of the License, or
   *   (at your option) any later version.
   *
   *   NOALYSS is distributed in the hope that it will be useful,
   *   but WITHOUT ANY WARRANTY; without even the implied warranty of
   *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *   GNU General Public License for more details.
   *
   *   You should have received a copy of the GNU General Public License
   *   along with NOALYSS; if not, write to the Free Software
   *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  /* $Revision$ */

  // Copyright (c) 2002 Author Dany De Bontridder dany@alchimerys.be

  /*!\file
   * \brief
   */

namespace  Belgian_Tax;
class Ext_List_Assujetti extends Listing {
  protected $variable = array(
			      "id"=>"a_id",
			      "date_decl"=>"date_decl",
			      "start_periode"=>"start_periode",
			      "end_periode"=>"end_periode",
			      "xml_file"=>"xml_file",
			      "num_tva"=>"num_tva",
			      "name"=>"tva_name",
			      "adress"=>"adress",
			      "country"=>"country",
			      "flag_periode"=>"flag_periode",
			      "exercice"=>"exercice",
			      "periode_dec"=>"periode_dec"
			      );
  private $aChild=array();
    public function __construct($p_cn)
    {
        parent::__construct($p_cn);
        $declarant=new XML\Declarant();
        $this->name=$declarant->name;
        $this->num_tva=$declarant->vatnumber;
        $this->adress=$declarant->street;
        $this->country=$declarant->city;
        $this->periode_dec=1;

    }
  static function choose_parameter($year,$amount_min,$all_customer) {
    global $g_tva_parameter;
    require_once $g_tva_parameter['template']."/ext_list_assujetti-choose_periode.php";
  }

  function from_array($p_array){
    if ( isset($p_array['name_child'])) {
      $name=$p_array['name_child'];
      $qcode=$p_array['qcode'];
      $code=$p_array['plugin_code'];
      $tva_num=$p_array['tva_num_child'];
      $amount=$p_array['amount'];
      $amount_vat=$p_array['amount_vat'];

      // retrieve missing and compute an array
      for ($i=0;$i<count($name);$i++){
	$child=new Ext_List_Assujetti_Child($this->db);
	$child->set_parameter('amount',$amount[$i]);
	$child->set_parameter('amount_vat',$amount_vat[$i]);
	$child->set_parameter('qcode',$qcode[$i]);
	$child->set_parameter('name_child',$name[$i]);
	$child->set_parameter('tva_num',$tva_num[$i]);

	$array[]=$child;
      }//end for
      $this->aChild=$array;
    } else
      $this->aChild=array();

    $this->start_periode=$p_array['start_periode'];
    $this->end_periode=$p_array['end_periode'];
    $this->flag_periode=$p_array['flag_periode'];
    //$this->periode_dec=$p_array['periode_dec'];
    $this->exercice=$p_array['exercice'];
  }
  function display() {
      $r= $this->menu();
    $r.= '<form class="print" id="readonly">';
	$r.=\HtmlInput::request_to_hidden(array('ac'));
    $r.=$this->display_info();
    $r.=$this->display_declaration_amount(true);
    $r.='</form>';
      $r.= create_script("$('readonly').disable();$('lk_tb_dsp').enable()");
      return $r;
  }
  function load() {
    $sql="select * from tva_belge.assujetti where a_id=$1";

    $res=$this->db->get_array(
			      $sql,
			      array($this->a_id)
			      );
    if ( $this->db->count() == 0 ) return 0;
    foreach ($res[0] as $idx=>$value) { $this->$idx=$value; }
    // load child
    $sql="select * from tva_belge.assujetti_chld where a_id=$1";
    $res=$this->db->get_array(
			      $sql,
			      array($this->a_id)
			      );
    $nb=$this->db->count();
    $array=array();
    // retrieve missing and compute an array
    for ($i=0;$i<$nb;$i++){
      $child=new Ext_List_Assujetti_Child($this->db);
      foreach ($res[$i] as $idx=>$value){
	$child->$idx=$value;
      }
      $array[]=$child;
    }//end for
    $this->aChild=$array;

    return 1;
  }
  function verify() {
    return 0;
  }
  function insert() {
    $this->db->start();

    /* insert into the first table */
    $sql=<<<EOF
      INSERT INTO tva_belge.assujetti(
				      start_date, end_date,  periodicity, tva_name,
				      num_tva, adress, country,  periode_dec,exercice)
      VALUES (to_date($1,'DD.MM.YYYY'),to_date($2,'DD.MM.YYYY'),$3,$4,$5,$6,$7,$8,$9) returning a_id;
EOF;
    $this->a_id=$this->db->get_value($sql,
				     array(
					   $this->start_periode, /* 1 */
					   $this->end_periode,
					   $this->flag_periode, /* 3 */
					   $this->name,
					   $this->num_tva, /* 5 */
					   $this->adress,
					   $this->country, /* 7 */
					   $this->periode_dec,
					   $this->exercice /* 9 */
					   )
				     );
    /* insert into the child table */
    for ($e=0;$e<count($this->aChild);$e++){
      $this->aChild[$e]->set_parameter('depend',$this->a_id);
      $this->aChild[$e]->insert();
    }
    $this->db->commit();

  }
  function update() {
  }
  /**
   * @brief Compute amount for all customer
   * @param float $amount_min amount minimum
   * @param int $all_customer[0-1] : 0 means all the customers 
   *                , 1 only customers with a VAT number
   */
  function compute($amount_min,$all_customer){

      $aInfo=$this->find_tva_acc('ASSUJETTI');
      $array=array();
      if (empty($aInfo)) $aInfo=[['pcm_val'=>'x','tva_id'=>-1,'ledger_id'=>-1]];

      foreach ($aInfo as $info) {
          // build a filter per ledger if requested
          $a_sql_param=array(
              $info['tva_id'],
              $info['pcm_val'],
              $this->start_periode,
              $this->end_periode,

          );
          $filter_ledger="";
          if ( $info['ledger_id']!="" ) {
              $filter_ledger=' and j_jrn_def=$5';
              $a_sql_param[]=$info['ledger_id'];
          }
          $sql = <<<EOF
    select fd1.ad_value j_qcode,sum(qs_price) amount,sum(qs_vat) amount_vat
                    from quant_sold
                    join jrnx using (j_id)
                    join fiche_detail fd1 on (qs_client=fd1.f_id and fd1.ad_id=23)
                    where 
                        qs_vat_code =$1 
                        and qs_fiche in (select f_id from fiche_detail where ad_id=5 and ad_value like $2)
                         and (j_date >= to_date($3,'DD.MM.YYYY') and j_date <= to_date($4,'DD.MM.YYYY'))
                    $filter_ledger
                    group by ad_value
EOF;

          $all = $this->db->get_array($sql,$a_sql_param);

          // retrieve missing and compute an array
          for ($i = 0; $i < count($all); $i++) {
              if ( $all[$i]['amount'] < $amount_min) continue;
              $child = new Ext_List_Assujetti_Child($this->db);


              $child->set_parameter('qcode', $all[$i]['j_qcode']);
              $fiche = new \Fiche($this->db);
              $fiche->get_by_qcode($all[$i]['j_qcode'], false);
              $num_tva = $fiche->strAttribut(ATTR_DEF_NUMTVA);
              if ( $all_customer == 1 && trim($num_tva??"") == "") continue;
              $child->set_parameter('tva_num', $num_tva);


              $child->set_parameter('amount', $all[$i]['amount']);
              $child->set_parameter('amount_vat', $all[$i]['amount_vat']);

              $child->set_parameter('name_child', $fiche->strAttribut(ATTR_DEF_NAME));

              $array[] = $child;
          }//end for
      }
    $this->aChild=$array;
  }
  /**
   *@brief display declaration
   * @param bool $readonly
   */
  function display_declaration_amount($readonly=false) {
    $res='<fieldset><h3>Listing</h3>';
    $res.=\HtmlInput::filter_table("tb_dsp", '0,1,2,3,4',1);
    $res.= '<table id="tb_dsp" class="result" style="width:80%;">';
    $js_clean="deleteRow('tb_dsp',this);";
    
    $r='';
    $r.=th('QuickCode');
    $r.=th('Name');
    $r.=th('Code Pays et numéro de TVA');
    $r.=th('montant CA');
    $r.=th('montant TVA');
    $r.=th('');
    $r.=th('');
    $amount=0;$amount_vat=0;
    $res.=tr($r);
    $a_vatnumber=array();
    $ck=new \ICheckBox("delIntra[]");
    $ck->set_range("delck");
    for ($i=0;$i<count($this->aChild);$i++) {
      $a=new \IHidden('qcode[]',$this->aChild[$i]->get_parameter('qcode'));
      $b=new \IText('name_child[]',$this->aChild[$i]->get_parameter('name_child'));
      if ( $readonly )
        $c=new \IText('tva_num_child[]',$this->aChild[$i]->get_parameter('tva_num'));
      else
        $c=new \IVATNumber('tva_num_child[]',$this->aChild[$i]->get_parameter('tva_num'));
      $e=new \INum('amount[]',$this->aChild[$i]->get_parameter('amount'));
      $d=new \INum('amount_vat[]',$this->aChild[$i]->get_parameter('amount_vat'));

      $amount+=round($this->aChild[$i]->get_parameter('amount'),2);
      $amount_vat+=round($this->aChild[$i]->get_parameter('amount_vat'),2);
      $r=td($a->input().\HtmlInput::card_detail($this->aChild[$i]->get_parameter('qcode')));
      $r.=td($b->input());
      $r.=td($c->input());
      $r.=td($e->input());
      $r.=td($d->input());
     if (! $readonly) {
        $r.=td(\Icon_Action::trash(uniqid(), $js_clean));
        $r.=td($ck->input());

     }
     $class=($i%2==0)?' class="odd" ':' class="even" ';
      $res.=tr($r,$class);

    }
	if ( $readonly )
	{
		$r=td('');
		$r.=td('');
		$r.=td(hb('Total'));
		$r.=td(hb(sprintf('%.02f',$amount)));
		$r.=td(hb(sprintf('%.02f',$amount_vat)));

		$res.=tr($r);
	}

    $res.='</table>';
    $res.='</fieldset>';


    return $res;
  }

    /**
     * @brief export the list of VAT customer in CSV : name, vat number, amount Wo/VAT , VAT
     * @param $p_id pk : tva_belge.assujetti.a_id
     */
  function export_csv($p_id)
  {
      $sql="
      select a.exercice,ac_tvanum,ac_amount, ac_vat ,ac_name
from tva_belge.assujetti a  join tva_belge.assujetti_chld  using (a_id)
where 
a_id=$1
      ";
      $a_row=$this->db->get_array($sql,array($p_id));
      if ( empty($a_row)) { return; }
      $nb_row=count($a_row);
      $csv=new \Noalyss_Csv(sprintf("listing-customer-%s",$a_row[0]['exercice']));
      $csv->send_header();
      $csv->write_header([_("nom"),_("tva"),_("montant HTVA"),_("montant tva")]);

      for ($i=0;$i<$nb_row;$i++)
      {
        $csv->add($a_row[$i]["ac_name"]);
        $csv->add($a_row[$i]["ac_tvanum"]);
        $csv->add($a_row[$i]["ac_amount"],"number");
        $csv->add($a_row[$i]["ac_vat"],"number");
        $csv->write();
      }


  }

    function menu($array=array())
    {
        $http = new \HttpInput();
        $dossier = \Dossier::id();
        $plugin_code = $http->request("plugin_code");
        $ac = $http->request("ac");
        $r = '';
        $js_remove=sprintf("onclick=\"if ( confirm(content[50])){remove_form('%s',%d,%d,'lc');}\"",
            $http->request('plugin_code'),
            \dossier::id(),
            $this->a_id);

        $array = array(
            array("extension.raw.php?".http_build_query(array(
                    "gDossier"=>$dossier,
                    "ac"=>$ac,
                    "plugin_code"=>$plugin_code,
                    "type"=>"lc",
                    "op"=>'xml_document',
                    'a_id'=>$this->a_id))
            , _("Déclaration XML"), _("Création du fichier xml"), 2),
            array("javascript:void(0)", _("Effacement déclaration"), _("Effacement déclaration"), 3, $js_remove),
            array("extension.raw.php?" . http_build_query(['gDossier' => $dossier,
                    "ac" => $ac,
                    "plugin_code" => $plugin_code,
                    "sa"=>"lc",
                    "op" => "exportcsv",
                    "a_id" => $this->a_id])
            , _("Export CSV"), _("Export du listing en CSV"), 4)

        );
        $r .=parent::menu($array);
        return $r;

    }
}

class Ext_List_Assujetti_Child extends \Belgian_Tax\Ext_List_Assujetti
{
  protected $variable=array(
			    "id"=>"ac_id",
			    "tva_num"=>"ac_tvanum",
			    "amount"=>"ac_amount",
			    "amount_vat"=>"ac_vat",
			    "depend"=>"a_id",
			    "qcode"=>"ac_qcode",
			    "name_child"=>'ac_name'
			    );
  function insert() {

    $sql=<<<EOF
      INSERT INTO tva_belge.assujetti_chld(
					   a_id, ac_tvanum, ac_amount, ac_vat,  ac_qcode,
					   ac_name)
      VALUES ($1, $2, $3, $4, $5, $6) returning ac_id;
EOF;
    $this->ic_id=$this->db->get_value($sql,array(
						 $this->a_id,
						 $this->ac_tvanum,
						 $this->ac_amount,
						 $this->ac_vat,
						 $this->ac_qcode,
						 $this->ac_name
						 ));
  }

}
