<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* $Revision$ */

// Copyright (c) 2002 Author Dany De Bontridder dany@alchimerys.be

/*!\file
 * \brief listing intracom
 */
echo '<div class="content" >';
\Noalyss\Dbg::echo_file(__FILE__);

$http=new \HttpInput();

/// var $year (int) year for the listing
$year=$http->request("year","string",date('Y')-1);

/// var $amount_min (float) minimum amount 
$amount_min=$http->request("amount_min","number",0);

/// var $all_customer (0-1) : 0 only customer with a valid VAT nb or 1 all of them
$all_customer=$http->request("all_customer","number",1);
// verify the year

if ( isset($_REQUEST['year']) && (trim(strlen($year)) < 4 || isNumber($year) == 0 ||$year < 2000|| $year >2100)) {
    alert(j(_('Année invalide'.' ['.$year.']')));
    echo \belgian_tax\Ext_List_Assujetti::choose_parameter($year,$amount_min,$all_customer);
    echo '</div>';
    exit;
}


// if the periode is not set we have to ask it
if ( ! isset($_REQUEST['decl']) ){
  echo \belgian_tax\Ext_List_Assujetti::choose_parameter($year,$amount_min,$all_customer);
  echo '</div>';
  exit;
}

$cn=\Dossier::connect();
if (isset($_POST['save'] )) {
  $save=new \belgian_tax\Ext_List_Assujetti($cn);
  $save->from_array($_POST);
  $save->insert();
  echo h2info(_('Déclaration sauvée'));
  echo $save->display();

  /**
   *@todo add a div for the button generate, get_xml, create ODS, print...
   */

  echo '</div>';
  exit;
}

$tva=new \belgian_tax\Ext_List_Assujetti($cn);

$str_quaterly='';
$str_month="";
$str_year=$year;
$str_byyear='1';
$str_quater='';
$str_hidden='';$str_submit='';$str_monthly='';
$by_year=true;
$tva->blank($year,1,3);


try {
  $r=$tva->compute($amount_min,$all_customer);
} catch (Exception $e) {

  echo \belgian_tax\Ext_List_Assujetti::choose_parameter($year,$amount_min,$all_customer);
  echo '</div>';
  return;
  }
global $g_tva_parameter;
require_once $g_tva_parameter['template'].'/form_periode.php';
echo '<form class="print" method="post">';
echo \dossier::hidden();
echo \HtmlInput::extension();
echo \HtmlInput::hidden('start_periode',$tva->start_periode);
echo \HtmlInput::hidden('end_periode',$tva->end_periode);
echo \HtmlInput::hidden('flag_periode',$tva->flag_periode);

echo \HtmlInput::hidden('exercice',$tva->exercice);
echo $tva->display_info();
echo $r;
echo $tva->display_declaration_amount();
echo \HtmlInput::submit('save',_('Sauvegarde'));
echo \HtmlInput::button('delsel','Effacer selection',"onclick=\"return TVA_plugin.delete_selection('delck')\"");

echo '</form>';
echo '</div>';

echo \ICheckBox::javascript_set_range("delck");