<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
// Copyright Author Dany De Bontridder danydb@aevalys.eu 22/10/23


/**
 * @file
 * @brief FORM for "Assujetti"
 */
$str_submit = \HtmlInput::submit('decl', _('Afficher'));

$i_year = new \IText('year');
$i_year->value = $year;
$i_year->size = 4;

$i_amount = new \INum('amount_min', $amount_min);

$is_all_customer = new \ISelect("all_customer");
$is_all_customer->transform ( array(
    0 => 'Tous les clients',
    1 => 'Clients avec un numéro de TVA'
));
?>


<form method="get" class="form_assujetti">
    <?= \HtmlInput::array_to_hidden(array('sa', 'ac', 'gDossier', 'plugin_code'), $_REQUEST) ?>
    <div class="assujetti_class">
        <div> 
            <div>Année</div>
            <div><?= $i_year->input() ?></div>
        </div>
        <div>
            <div>Montant minimum</div>
            <div><?= $i_amount->input() ?></div>
        </div>
        <div>
            <div>Client </div>
            <div><?=$is_all_customer->input()?></div>
        </div>
    </div>
    <div>
        <?= $str_submit ?>
    </div>
</form>